import { d as attr_class, b as attr, s as store_get, g as attr_style, e as escape_html, u as unsubscribe_stores, h as bind_props, p as pop, a as push, f as stringify } from "./index2.js";
import { p as proxyGoogleImage, g as getBestThumbnail } from "./images.js";
import { l as letterCase } from "./letterCasing.js";
import { v as videoLength, c as cleanNumber } from "./numbers.js";
import { o as onDestroy } from "./index-server.js";
import { $ as $format } from "./runtime.js";
import { g as get } from "./index.js";
import { a as getChannel } from "./index3.js";
import { t as truncate } from "./misc.js";
import { s as syncPartyPeerStore, i as interfaceLowBandwidthMode, c as interfaceDisplayThumbnailAvatars, p as playerSavePlaybackPositionStore } from "./store.js";
/* empty css                                        */
function Thumbnail($$payload, $$props) {
  push();
  var $$store_subs;
  let {
    video = void 0,
    playlistId = "",
    sideways = false
  } = $$props;
  let authorImg = void 0;
  let placeholderHeight = 0;
  let watchUrl = new URL(`${location.origin}/watch/${video.videoId}`);
  if (playlistId !== "") {
    watchUrl.searchParams.set("playlist", playlistId);
  }
  syncPartyPeerStore.subscribe((peer) => {
    if (peer) {
      watchUrl.searchParams.set("sync", peer.id);
    }
  });
  let progress = void 0;
  if (get(playerSavePlaybackPositionStore)) {
    try {
      progress = localStorage.getItem(`v_${video.videoId}`) ?? void 0;
    } catch {
      progress = void 0;
    }
  } else {
    progress = void 0;
  }
  let startedSideways = sideways === true;
  function disableSideways() {
    if (!startedSideways) return;
    if (window.innerWidth <= 1500) {
      sideways = false;
      if (typeof authorImg === "undefined") loadAuthor();
    } else sideways = true;
  }
  async function loadAuthor() {
    if (!get(interfaceDisplayThumbnailAvatars)) return;
    try {
      const channel = await getChannel(video.authorId, { priority: "low" });
      const loadedPfp = new Image();
      loadedPfp.src = proxyGoogleImage(getBestThumbnail(channel.authorThumbnails, 75, 75));
      loadedPfp.onload = () => {
        authorImg = loadedPfp;
      };
    } catch {
    }
  }
  onDestroy(() => {
    removeEventListener("resize", disableSideways);
  });
  $$payload.out += `<div${attr_class("svelte-ejk2dv", void 0, { "sideways-root": sideways })}><div id="thumbnail-container" role="region"><a class="wave thumbnail svelte-ejk2dv"${attr("href", watchUrl.toString())} data-sveltekit-preload-data="off">`;
  if (!store_get($$store_subs ??= {}, "$interfaceLowBandwidthMode", interfaceLowBandwidthMode)) {
    $$payload.out += "<!--[-->";
    {
      $$payload.out += "<!--[-->";
      $$payload.out += `<div class="secondary-container"${attr_style(`width: 100%;height: ${stringify(placeholderHeight)}px;`)}></div>`;
    }
    $$payload.out += `<!--]-->`;
  } else {
    $$payload.out += "<!--[!-->";
  }
  $$payload.out += `<!--]--> `;
  if (progress) {
    $$payload.out += "<!--[-->";
    $$payload.out += `<progress class="absolute right bottom" style="z-index: 1;"${attr("value", progress)}${attr("max", video.lengthSeconds)}></progress>`;
  } else {
    $$payload.out += "<!--[!-->";
  }
  $$payload.out += `<!--]--> `;
  if (!("liveVideo" in video) || !video.liveVideo) {
    $$payload.out += "<!--[-->";
    if (video.lengthSeconds !== 0) {
      $$payload.out += "<!--[-->";
      if (!store_get($$store_subs ??= {}, "$interfaceLowBandwidthMode", interfaceLowBandwidthMode)) {
        $$payload.out += "<!--[-->";
        $$payload.out += `<div class="absolute right bottom small-margin black white-text small-text thumbnail-corner"> ${escape_html(videoLength(video.lengthSeconds))} </div>`;
      } else {
        $$payload.out += "<!--[!-->";
        $$payload.out += `<h3>${escape_html(videoLength(video.lengthSeconds))}</h3>`;
      }
      $$payload.out += `<!--]-->`;
    } else {
      $$payload.out += "<!--[!-->";
    }
    $$payload.out += `<!--]-->`;
  } else if (video.lengthSeconds !== 0) {
    $$payload.out += "<!--[1-->";
    $$payload.out += `<div class="absolute right bottom small-margin red white-text small-text thumbnail-corner">${escape_html(store_get($$store_subs ??= {}, "$_", $format)("thumbnail.live"))}</div>`;
  } else {
    $$payload.out += "<!--[!-->";
    $$payload.out += `<h3>${escape_html(store_get($$store_subs ??= {}, "$_", $format)("thumbnail.live"))}</h3>`;
  }
  $$payload.out += `<!--]--></a></div> <div class="thumbnail-details video-title svelte-ejk2dv">`;
  if (!sideways && !store_get($$store_subs ??= {}, "$interfaceLowBandwidthMode", interfaceLowBandwidthMode) && store_get($$store_subs ??= {}, "$interfaceDisplayThumbnailAvatars", interfaceDisplayThumbnailAvatars)) {
    $$payload.out += "<!--[-->";
    $$payload.out += `<div style="margin-right: 1em;">`;
    if (authorImg) {
      $$payload.out += "<!--[-->";
      $$payload.out += `<img${attr("src", authorImg.src)} alt="Author" class="circle small">`;
    } else {
      $$payload.out += "<!--[!-->";
      $$payload.out += `<progress style="padding: 15px;" class="circle small"></progress>`;
    }
    $$payload.out += `<!--]--></div>`;
  } else {
    $$payload.out += "<!--[!-->";
  }
  $$payload.out += `<!--]--> <div class="video-title svelte-ejk2dv"><a style="padding-left: 1px;" class="video-title svelte-ejk2dv" data-sveltekit-preload-data="off"${attr("href", watchUrl.toString())}><span class="bold">${escape_html(letterCase(truncate(video.title.trimEnd(), 80)))}</span></a> <div><a${attr("href", `/channel/${video.authorId}`)}${attr_class("", void 0, { "author": !sideways })}>${escape_html(video.author)}</a> `;
  if (!("publishedText" in video) && "viewCountText" in video) {
    $$payload.out += "<!--[-->";
    $$payload.out += `<span style="margin-top: 1em;">• ${escape_html(video.viewCountText)}
						${escape_html(store_get($$store_subs ??= {}, "$_", $format)("views"))}</span>`;
  } else {
    $$payload.out += "<!--[!-->";
  }
  $$payload.out += `<!--]--> `;
  if ("publishedText" in video) {
    $$payload.out += "<!--[-->";
    $$payload.out += `<div class="max">${escape_html(cleanNumber(video.viewCount))} • ${escape_html(video.publishedText)}</div>`;
  } else {
    $$payload.out += "<!--[!-->";
  }
  $$payload.out += `<!--]--></div></div></div></div>`;
  if ($$store_subs) unsubscribe_stores($$store_subs);
  bind_props($$props, { video, sideways });
  pop();
}
export {
  Thumbnail as T
};
