import { BinaryReader, BinaryWriter } from "@bufbuild/protobuf/wire";
import { MediaCapabilities } from "./media_capabilities.js";
export declare const protobufPackage = "video_streaming";
export interface ClientAbrState {
    timeSinceLastManualFormatSelectionMs?: number | undefined;
    lastManualDirection?: number | undefined;
    quality?: number | undefined;
    detailedNetworkType?: number | undefined;
    maxWidth?: number | undefined;
    maxHeight?: number | undefined;
    selectedQualityHeight?: number | undefined;
    r7?: number | undefined;
    startTimeMs?: number | undefined;
    timeSinceLastSeek?: number | undefined;
    visibility?: number | undefined;
    timeSinceLastReq?: number | undefined;
    mediaCapabilities?: MediaCapabilities | undefined;
    timeSinceLastAction?: number | undefined;
    /** optional int32 Gw = 40; */
    mediaType?: ClientAbrState_MediaType | undefined;
    playerState?: number | undefined;
    rangeCompression?: boolean | undefined;
    Jda?: number | undefined;
    qw?: number | undefined;
    Ky?: number | undefined;
    sabrReportRequestCancellationInfo?: number | undefined;
    l?: boolean | undefined;
    G7?: number | undefined;
    preferVp9?: boolean | undefined;
    qj?: number | undefined;
    Hx?: number | undefined;
    isPrefetch?: boolean | undefined;
    sabrSupportQualityConstraints?: number | undefined;
    sabrLicenseConstraint?: Uint8Array | undefined;
    allowProximaLiveLatency?: number | undefined;
    sabrForceProxima?: number | undefined;
    Tqb?: number | undefined;
    sabrForceMaxNetworkInterruptionDurationMs?: number | undefined;
    playbackRate?: number | undefined;
}
export declare enum ClientAbrState_MediaType {
    MEDIA_TYPE_DEFAULT = 0,
    MEDIA_TYPE_AUDIO = 1,
    MEDIA_TYPE_VIDEO = 2,
    USE_SERVER_FORMAT_FILTER = 3,
    UNRECOGNIZED = -1
}
export declare function clientAbrState_MediaTypeFromJSON(object: any): ClientAbrState_MediaType;
export declare function clientAbrState_MediaTypeToJSON(object: ClientAbrState_MediaType): string;
export declare const ClientAbrState: MessageFns<ClientAbrState>;
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
type KeysOfUnion<T> = T extends T ? keyof T : never;
export type Exact<P, I extends P> = P extends Builtin ? P : P & {
    [K in keyof P]: Exact<P[K], I[K]>;
} & {
    [K in Exclude<keyof I, KeysOfUnion<P>>]: never;
};
export interface MessageFns<T> {
    encode(message: T, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): T;
    fromJSON(object: any): T;
    toJSON(message: T): unknown;
    create<I extends Exact<DeepPartial<T>, I>>(base?: I): T;
    fromPartial<I extends Exact<DeepPartial<T>, I>>(object: I): T;
}
export {};
