import { BinaryReader, BinaryWriter } from "@bufbuild/protobuf/wire";
export declare const protobufPackage = "video_streaming";
export interface MediaCapabilities {
    videoFormatCapabilities: MediaCapabilities_VideoFormatCapability[];
    audioFormatCapabilities: MediaCapabilities_AudioFormatCapability[];
    hdrModeBitmask?: number | undefined;
}
export interface MediaCapabilities_VideoFormatCapability {
    videoCodec?: number | undefined;
    maxHeight?: number | undefined;
    maxWidth?: number | undefined;
    maxFramerate?: number | undefined;
    maxBitrateBps?: number | undefined;
    is10BitSupported?: boolean | undefined;
}
export interface MediaCapabilities_AudioFormatCapability {
    audioCodec?: number | undefined;
    numChannels?: number | undefined;
    maxBitrateBps?: number | undefined;
    spatialCapabilityBitmask?: number | undefined;
}
export declare const MediaCapabilities: MessageFns<MediaCapabilities>;
export declare const MediaCapabilities_VideoFormatCapability: MessageFns<MediaCapabilities_VideoFormatCapability>;
export declare const MediaCapabilities_AudioFormatCapability: MessageFns<MediaCapabilities_AudioFormatCapability>;
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
type KeysOfUnion<T> = T extends T ? keyof T : never;
export type Exact<P, I extends P> = P extends Builtin ? P : P & {
    [K in keyof P]: Exact<P[K], I[K]>;
} & {
    [K in Exclude<keyof I, KeysOfUnion<P>>]: never;
};
export interface MessageFns<T> {
    encode(message: T, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): T;
    fromJSON(object: any): T;
    toJSON(message: T): unknown;
    create<I extends Exact<DeepPartial<T>, I>>(base?: I): T;
    fromPartial<I extends Exact<DeepPartial<T>, I>>(object: I): T;
}
export {};
