import { BinaryReader, BinaryWriter } from "@bufbuild/protobuf/wire";
import { CryptoParams } from "./crypto_params.js";
import { OnesieHeaderType } from "./onesie_header_type.js";
export declare const protobufPackage = "video_streaming";
export interface OnesieHeader {
    type?: OnesieHeaderType | undefined;
    videoId?: string | undefined;
    itag?: string | undefined;
    cryptoParams?: CryptoParams | undefined;
    lastModified?: number | undefined;
    mediaSizeBytes?: number | undefined;
    restrictedFormats: string[];
    xtags?: string | undefined;
    sequenceNumber?: number | undefined;
    field23?: OnesieHeader_Field23 | undefined;
    field34?: OnesieHeader_Field34 | undefined;
}
export interface OnesieHeader_Field23 {
    videoId?: string | undefined;
}
export interface OnesieHeader_Field34 {
    itagDenylist: string[];
}
export declare const OnesieHeader: MessageFns<OnesieHeader>;
export declare const OnesieHeader_Field23: MessageFns<OnesieHeader_Field23>;
export declare const OnesieHeader_Field34: MessageFns<OnesieHeader_Field34>;
type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export type DeepPartial<T> = T extends Builtin ? T : T extends globalThis.Array<infer U> ? globalThis.Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
type KeysOfUnion<T> = T extends T ? keyof T : never;
export type Exact<P, I extends P> = P extends Builtin ? P : P & {
    [K in keyof P]: Exact<P[K], I[K]>;
} & {
    [K in Exclude<keyof I, KeysOfUnion<P>>]: never;
};
export interface MessageFns<T> {
    encode(message: T, writer?: BinaryWriter): BinaryWriter;
    decode(input: BinaryReader | Uint8Array, length?: number): T;
    fromJSON(object: any): T;
    toJSON(message: T): unknown;
    create<I extends Exact<DeepPartial<T>, I>>(base?: I): T;
    fromPartial<I extends Exact<DeepPartial<T>, I>>(object: I): T;
}
export {};
