import type { FormatId } from '../../protos/generated/misc/common.js';
export declare enum QUALITY {
    AUTO = 0,
    TINY = 144,
    SMALL = 240,
    MEDIUM = 360,
    LIGHT = 144,
    LARGE = 480,
    HD720 = 720,
    HD1080 = 1080,
    HD1440 = 1440,
    HD2160 = 2160,
    HD2880 = 2880,
    HIGHRES = 4320
}
export declare enum PART {
    ONESIE_HEADER = 10,
    ONESIE_DATA = 11,
    MEDIA_HEADER = 20,
    MEDIA = 21,
    MEDIA_END = 22,
    LIVE_METADATA = 31,
    HOSTNAME_CHANGE_HINT = 32,
    LIVE_METADATA_PROMISE = 33,
    LIVE_METADATA_PROMISE_CANCELLATION = 34,
    NEXT_REQUEST_POLICY = 35,
    USTREAMER_VIDEO_AND_FORMAT_DATA = 36,
    FORMAT_SELECTION_CONFIG = 37,
    USTREAMER_SELECTED_MEDIA_STREAM = 38,
    FORMAT_INITIALIZATION_METADATA = 42,
    SABR_REDIRECT = 43,
    SABR_ERROR = 44,
    SABR_SEEK = 45,
    RELOAD_PLAYER_RESPONSE = 46,
    PLAYBACK_START_POLICY = 47,
    ALLOWED_CACHED_FORMATS = 48,
    START_BW_SAMPLING_HINT = 49,
    PAUSE_BW_SAMPLING_HINT = 50,
    SELECTABLE_FORMATS = 51,
    REQUEST_IDENTIFIER = 52,
    REQUEST_CANCELLATION_POLICY = 53,
    ONESIE_PREFETCH_REJECTION = 54,
    TIMELINE_CONTEXT = 55,
    REQUEST_PIPELINING = 56,
    SABR_CONTEXT_UPDATE = 57,
    STREAM_PROTECTION_STATUS = 58,
    SABR_CONTEXT_SENDING_POLICY = 59,
    LAWNMOWER_POLICY = 60,
    SABR_ACK = 61,
    END_OF_TRACK = 62,
    CACHE_LOAD_POLICY = 63,
    LAWNMOWER_MESSAGING_POLICY = 64,
    PREWARM_CONNECTION = 65
}
export declare function u8ToBase64(u8: Uint8Array): string;
export declare function base64ToU8(base64: string): Uint8Array;
export declare function getFormatKey(formatId: FormatId): string;
export declare function concatenateChunks(chunks: Uint8Array[]): Uint8Array;
export declare class CustomEvent extends Event {
    #private;
    constructor(type: string, options?: CustomEventInit<any[]>);
    get detail(): any[] | null;
}
